(Leetcode)Longest Increasing Subsequence——dp,bisearch

来源:互联网 发布:java多线程优点 编辑:程序博客网 时间:2024/06/03 09:24

300. Longest Increasing Subsequence

题目
Given an unsorted array of integers, find the length of longest increasing subsequence.

For example,
Given [10, 9, 2, 5, 3, 7, 101, 18],
The longest increasing subsequence is [2, 3, 7, 101], therefore the length is 4. Note that there may be more than one LIS combination, it is only necessary for you to return the length.

Your algorithm should run in O(n2) complexity.

Follow up: Could you improve it to O(n log n) time complexity?

Solution 1: DP(9ms)——O(n2

每个dp[i]存储到当前元素的最大子数组长度。

Code(C)

int lengthOfLIS(int* nums, int numsSize) {    if(numsSize<=0) return 0;     int *dp = (int *) malloc(sizeof(int)*numsSize);    dp[0] = 0;    int i=0;     int maxl = 1;    for(i=0; i<numsSize; i++){        int j=0;        int cur = nums[i];        dp[i] = 1;        for(j=i-1; j>=0; j--){            if(nums[j]<cur){                if((j+2)<dp[i]) break;                dp[i] = ( dp[i] < (dp[j]+1) ) ? dp[j]+1 : dp[i];            }        }        maxl = (maxl>dp[i]) ? maxl : dp[i];    }    free(dp);    return maxl;}

Solution 2: DP(3ms)——O(nlog(n)

每个dp[i]前面构成长度为(i+1)的子序列,这个序列的最小的末尾数字。

/** * if find target, return the index of target * else, return (-(insertion point) - 1). * The insertion point is defined as the point at which the key would be inserted into the array. * same as Arrays.binearysearch() in java */int bisearch(int *nums, int low, int high, int target){    if(low <= high){        int mid = (low+high)/2;        if(nums[mid]==target) return mid;        else if(nums[mid]>target) return bisearch(nums, low, mid-1, target);        else return bisearch(nums, mid+1, high, target);    }    else{        return (-low-1);    }}int lengthOfLIS(int* nums, int numsSize) {    if (numsSize <= 0) return 0;    int *dp = (int *)malloc(sizeof(int)*numsSize);    dp[0] = nums[0];    int i = 0;    int maxl = 0;    for (i = 1; i<numsSize; i++){        int cur = nums[i];        int idx = bisearch(dp, 0, maxl, cur);        if (idx<0) idx = -(idx + 1); // get insert idx of cur        dp[idx] = cur;        if (idx == (maxl+1)) maxl++;    }    free(dp);    return maxl+1;}
0 0
原创粉丝点击